<!DOCTYPE HTML>
<html lang="en">
<head>
  <title>MyCanvas</title>
  <meta charset="UTF-8" >
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="p5js MyCanvas reference.">
  <meta name="keywords" content="p5js, MyCanvas, reference ">
  <meta name="ROBOTS" content="INDEX, FOLLOW">
   <style>
   body {width: 800px; background-color: silver;}
    h1 {text-align: center; color: blue;}
    h2 {text-align: center; color: dodgerBlue}
    .table2 {border-collapse: collapse; border: 1px solid black; background-color: aqua;}
    td {border: 1px solid black; padding-left: 4px; padding-right: 4px;}
    th {border: 1px solid black; padding-left: 4px; padding-right: 4px;}
    .td {padding-left: 6px; padding-right: 6px}	
  </style>
  <script src="http://www.brinkje.com/p5js/p5.min.js"></script>
  <script src="MyCanvas.pjs"></script>
</head>
<body>
<h1 id = "top">MyCanvas</h1>
<p>MyCanvas is a p5.js class that has a HTML canvas that allows <i>multiple</i>
  canvases on the same web page.  Several of the normal p5.js methods
  (as named in 
  <a href = "#methods">Properties, Methods, and Events listing</a> and in
   the <a href = "#testing">Testing and Syntax</a> table) have been
  rewritten to operate in a MyCanvas.</p>
<p>At this point, when writing p5js methods for MyCanvas, very little attention
  has been paid validating parameters.  No "z" parameters have
  been used.  There has been no attempt to make these methods work in the
  webgl.  Documentation is typically quite limited.  What is available is on the 
  test pages marked with an "x" in the 
  <a href = "#testing">Testing and Syntax</a> table.  Because, the MyCanvas
  methods are typically similar to those in p5js, one can find further
  information from the p5js references.</p>
<p>Some applications:</p>
<ul>
  <li><a href = "simplisticExample.html">simplisticExample.html</a>: A simple example
     with two MyCanvas and only 13 lines of p5.js code.</li>
  <li><a href = "instanceMode.html">instanceMode.html</a> A rewrite of the
     simplistic example using instance mode.  It took me 22 lines of code.</a>
  <li><a href = "instanceMode2.html">instanceMode2.html</a> Another attempt
     at using instance mode.  I was unable to get mouse events to work as 
     desired.</li>
  <li><a href = "myCanvas2.html">myCanvas2.html</a> A rewrite of instanceMode2.html using
     myCanvas.  The mouse events work as expected.</li>
  <li><a href = "ball.html">ball.html</a>: A rewrite of 
     <a href = "https://www.youtube.com/watch?v=fbqboV1iHy0">
     SonnySanberg demo<a> with three bouncing ball using MyCanvases.</li>
  <li><a href = "Birthday.html">Birthday.html</a>: A fun application that shows
     a few of the things that can be done with a MyCanvas (and could be done
     with a regular p5js canvas.)</li>
  <li><a href =  "TV.html">TV.html</a>: It has four different "TV" monitors with
    MyCanvas screens.  Each of the screens is doing something different.</li>
  <li><a href = "Enlarge.html">Enlarge.html</a>:  Allows one to load a large
     image file into one MyCanvas and then look at a enlarge portion of it in a
     second MyCanvas.</li>
  <li><a href = "bezier.html">bezier.html</a>:  Demonstrates (and test) bezier
     curves in two different MyCanvases.</li>
</ul>
<p>A table showing <a href = "implimentation.html"> methods and properties
   implemented</a> by p5js canvas and MyCanvas.</p>
<p><a href = "myCanvas.zip">Download all the myCanvas files</a> as a zip file</p>

<p>Simple example:  The result is shown in the div with id = "example" on the right.</p>
<table>
  <tr><td>
<pre>function setup() {
  canvas1 = createMyCanvas(100, 150);
  canvas1.background(210);
  canvas1.fill("red");
  canvas1.rect(20, 40, 60, 50);
  canvas1.text("A MyCanvas", 10, 130);

  canvas2 = createMyCanvas(150, 100);
  canvas2.background(200, 200, 255);
  canvas2.text("Another MyCanvas", 10, 90);
  canvas2.stroke("#008000");
  canvas2.line(20, 10, 130, 90);

  canvas1.parent("example");
  canvas2.parent("example");
}
</pre>
</td><td>
<div id = "example"></div>
</td><tr>
</table>


<p>When using MyCanvases, the most common error is to forgetting to prefix
  the method name, mouseX, and mouseY  with the canvas name.</p>
<table id = "methods">
  <tr>
    <td class = "td">
      <h2>Initialization</h2>
        createMyCanvas
      <h2>Properties</h2>
       mouseX<br>
       mouseY<br>
       isOver *<br>
       mouseIsPressed<br>
       keyIsPressed<br>
       elt<br>
       canvas<br>
       touches
      <h2>Data</h2>
        _backgroundColor*<br>
        _colorMode<br>
        _colorMaxes<br>
        _fillColor*<br>
        _rectMode<br>
        _ellipseMode<br>
        _fillColor*<br>
        _strokeColor*<br>
        _textSize<br>
        _textFont</br>
        _textLeading</br>
        _textStyle
     <h2>_myMainCanvas</h2>
        _myMainCanvas<br>
        myBackground<br>
        myRect
    </td>
    <td  class = "td">
      <h2>Methods</h2>
        id<br>
        parent<br>
        child<br>
        resizeCanvas<br>
        color<br>
        colorMode<br>
        style<br>
        position<br>
        center<br>
        html<br>
        fill<br>
        noFill<br>
        stroke<br>
        noStroke<br>
        strokeWeight<br>
        strokeCap<br>
        background<br>
        clear<br>
        point<br>
        line<br>
        rect<br>
        rectMode<br>
        ellipse<br>
        ellipseMode<br>
        arc<br>
        triangle<br>
        quad<br>
        square<br>
        circle<br>
        bezier<br>
        bezierPoint<br>
        bezierTangent<br>
        text<br>
        textSize<br>
        textAlign (horizontal alignment only)<br>
        textFont<br>
        textStyle<br>
        rotate<br>
        translate<br>
        scale<br>
        convertImageToMyCanvas*<br>
        hide<br>
        show<br>
        loadImage<br>
        image<br>
        browse*<br>
        applyMatrix<br>
        resetMatrix<br>
        beginShape<br>
        endShape<br>
        vertex
    </td>
    <td class = "td">
      <h2>Events</h2>
        mousePressed<br>
        mouseReleased<br>
        mouseClicked<br>
        doubleClicked<br>
        mouseWheel<br>
        mouseMoved<br>
        mouseOver<br>
        mouseOut<br>
        keyDown*<br>
        keyUp*<br>
        touchStarted<br>
        touchMoved<br>
        touchEnded<br>
        dragOver<br>
        dragLeave<br>
        drop
    </td>
  </tr>
</table>
<p>* not a standard p5.js property, method or event.</p>

<h2 id = "testing">Testing and Syntax</h2>
<p>Key:  u - method is used. &nbsp; x - primary example, test, syntax, and 
    some documentation comments.  The links are to .html files with that name.
    </p>
<table  class = "table2">
  <tr><th>Method or Property</th>
        <th><a href = "shapeText.html">shapeText</a></th>
        <th><a href = "transforms.html">transforms</a></th>
        <th><a href = "bezier.html">bezier</a></th>
        <th><a href = "colors.html">colors</a></th>
        <th><a href = "events.html">events</a></th>
        <th><a href = "domImage.html">domImage</a></th>
        <th><a href = "myMain.html">myMain</a></th>
        <th><a href = "child.html">child</a></th>
        <th><a href = "moreTests.html">moreTests</a></th>
  </tr><tr>
        <td colspan="10"><center><b>Creation</b></center></td>
   </tr><tr>
        <td>createMyCanvas<br>(Number of MyCanvas)</td>
        <td>u (3)</td><td>u (1)</td><td>u (2)</td><td>u (1)</td><td>u (1)</td>
               <td>x (3)</td><td>u (2)</td><td>u (3)</td><td>u (2)</td>
  </tr><tr>
        <td colspan="10"><center><b>_myMainCanvas</b></center></td>
  </tr><tr>
        <td>_myMainCanvas</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td>x</td>
           <td></td><td></td>
  </tr><tr>
        <td>myBackground</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td>x</td>
        <td></td><td></td>
  </tr><tr>
        <td>myRect</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td>x</td>
           <td></td>
  </tr><tr>
        <td colspan="10"><center><b>Methods</b></center></td>
   </tr><tr>
        <td>id</td>
           <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
           <td></td><td></td>
   </tr><tr>
        <td>parent</td>
           <td>u</td><td>u</td><td>u</td><td>u</td><td>u</td><td>x</td><td></td>
           <td></td><td></td>
   </tr><tr>
          <td>child</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
           <td>x</td><td></td>
   </tr><tr>
          <td>resizeCanvas</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
           <td></td><td>x</td>
   </tr><tr>
        <td>color</td>
          <td></td><td></td><td></td><td>x</td><td></td><td></td><td></td>
          <td></td><td></td>
   </tr><tr>
        <td>colorMode</td>
        <td colspan = "2"><a href = "colorModeTest.html">colorModeTest.html</a>
        <td></td><td></td><td></td><td></td><td></td>
          <td></td><td></td>
   </tr><tr>
        <td>style</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td>x</td>
   </tr><tr>
        <td>position</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td>x</td>
   </tr><tr>
        <td>center</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td>x</td>
   </tr><tr>
        <td>html</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td>x</td>
   </tr><tr>
        <td>fill, noFill<br>stroke, noStroke</td>
           <td>u</td><td>u</td><td>u</td><td>x</td><td>u</td><td>u</td><td></td>
           <td></td><td></td>
   </tr><tr>
       <td>strokeWeight</td>
         <td>x</td><td></td><td></td><td>u</td><td></td><td></td><td></td>
         <td></td><td></td>
   </tr><tr>
       <td>strokeCap</td>
         <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
         <td></td><td></td>
   </tr><tr>
        <td>background</td>
        <td>u</td><td>u</td><td>u</td><td>x</td><td>u</td><td>u</td><td>u</td>
        <td>u</td><td>u</td>
   </tr><tr>
        <td>clear</td>
        <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>point</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
       <td></td><td></td>
   </tr><tr>
        <td>rect</td>
        <td>x</td><td>u</td><td>u</td><td>u</td><td>u</td><td>u</td><td>u</td>
       <td></td><td>u</td>
   </tr><tr>
        <td>rectMode</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>line</td>
        <td>x</td><td></td><td>u</td><td></td><td>u</td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>ellipse</td>
        <td>x</td><td>u</td><td>u</td><td></td><td>u</td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>ellipseMode</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
    </tr><tr>
        <td>arc</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
        <td>triangle<br>quad</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>circle<br>square</td>
        <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>bezier<br>bezierPoint<br>bezierTangent
       <td></td><td></td><td>x</td><td></td><td></td><td></td><td></td>
       <td></td><td></td>
   </tr><tr>
     <td>text</td>
     <td>x</td><td>u</td><td>u</td><td>u</td><td></td><td>u</td><td></td>
     <td>u</td><td>u</td>
   </tr><tr>
        <td>textSize</td>
        <td>x</td><td>u</td><td>u</td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>textAlign<br>textFont<br>textStyle</td>
       <td>x</td><td></td><td></td><td></td><td></td><td></td><td></td>
       <td></td><td></td>
   </tr><tr>
        <td>rotate<br>translate<br>scale</td>
        <td></td><td>x</td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
    </tr><tr>
          <td>hide</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
           <td></td><td>x</td>
   </tr><tr>
          <td>show</td>
           <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
           <td></td><td>x</td>
  </tr><tr>
        <td>convertImageToMyCanvas*</td>
      <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
      <td></td><td></td>
   </tr><tr>
        <td>loadImage</td>
      <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
      <td></td><td></td>
   </tr><tr>
        <td>image</td>
      <td></td><td></td><td>u</td><td></td><td>u</td><td>x</td><td></td>
      <td></td><td></td>
   </tr><tr>
        <td>browse*</td>
      <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
      <td></td><td></td>
   </tr><tr>
        <td>applyMatrix<br>resetMatrix</td>
        <td></td><td></td><td></td><td></td><td></td><td>x</td><td></td>
        <td></td><td></td>
   </tr><tr>
        <td>cbeginShape<br>endShape<br>vertex</td>
        <td colspan = "2"><a href = "shapesTest.html">shapesTest.html</a>
        <td></td><td></td><td></td><td></td><td></td>
          <td></td><td></td>

  </tr><tr>
        <td colspan="10"><center><b>Events</b></center></td>
  </tr><tr>
        <td>mousePressed<br>mouseReleased<br>mouseMoved</td>
         <td></td><td></td><td>u</td><td></td><td>x</td><td></td><td></td>
         <td></td><td></td>
   </tr><tr>
        <td>doubleClicked<br>mouseWheel<br>mouseOver<br>mouseOver<br>
             mouseOut</td>
        <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
         <td>keyDown *<br>keyUp *</td>
        <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
         <td>touchStarted<br>touchMoved<br>touchEnded</td>
        <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
         <td>dragOver<br>dragLeave</td>
        <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
         <td>drop</td>
        <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
       <td></td><td></td>
   </tr><tr>
       <td colspan="10"><center><b>Properties</b></center></td>
   </tr><tr>
          <td>mouseX<br>mouseY</td>
            <td></td><td></td><td>u</td><td></td><td>x</td><td></td><td></td>
            <td></td><td></td>
   </tr><tr>
        <td>isOver *<br>mouseIsPressed<br>keyIsPressed</td>
           <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
           <td></td><td></td>
     </tr><tr>
        <td>elt</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td>x</td><td></td>
     </tr><tr>
        <td>canvas</td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td>x</td><td></td>
   </tr><tr>
          <touches</td>
            <td></td><td></td><td></td><td></td><td>x</td><td></td><td></td>
            <td></td><td></td>
    </tr><!--<tr>
       <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
       <td></td><td></td>
   </tr><tr>
        <td></td>
        <td></td><td></td><td></td><td></td><td></td><td></td><td></td>
        <td></td><td></td>
  </tr><tr>
         <td></td><td></td>
     </tr>     
-->
</table>
<p>* not a standard p5.js property or event.</p>

<p>The p5.js file: <a href = "myCanvas.pjs">myCanvas.pjs</a></p>
<p>James Brink, 05/26/2020</p>


<script>
function setup() {
  canvas1 = createMyCanvas(100, 150);
  canvas1.background(210);
  canvas1.fill("red");
  canvas1.rect(20, 40, 60, 50);
  canvas1.text("A MyCanvas", 10, 130);

  canvas2 = createMyCanvas(150, 100);
  canvas2.background(200, 200, 255);
  canvas2.text("Another MyCanvas", 10, 90);
  canvas2.stroke("#008000");
  canvas2.line(20, 10, 130, 90);

  canvas1.parent("example");
  canvas2.parent("example");
}
</script>
<div> 
<?php
 $handle = fopen("counter.txt", "r");
 if(!$handle){
   echo "could not open the file"; }
 else  {
   $counter=(int )fread($handle,20);
   fclose($handle); $counter++;
   echo"This page has been viewed " . $counter . " times";
   $handle= fopen("counter.txt", "w" ) ;
   fwrite($handle,$counter) ;
   fclose ($handle) ; 
  } 
?>
</div>
</body>
</html>
